# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from kuavo_msgs/twoArmHandPose.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import kuavo_msgs.msg
import std_msgs.msg

class twoArmHandPose(genpy.Message):
  _md5sum = "5bdb1e027f430369b6f88e5e2f5d31ca"
  _type = "kuavo_msgs/twoArmHandPose"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """Header header
armHandPose  left_pose
armHandPose  right_pose
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: kuavo_msgs/armHandPose
float64[3] pos_xyz
float64[4] quat_xyzw

float64[3] elbow_pos_xyz

float64[7] joint_angles"""
  __slots__ = ['header','left_pose','right_pose']
  _slot_types = ['std_msgs/Header','kuavo_msgs/armHandPose','kuavo_msgs/armHandPose']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,left_pose,right_pose

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(twoArmHandPose, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.left_pose is None:
        self.left_pose = kuavo_msgs.msg.armHandPose()
      if self.right_pose is None:
        self.right_pose = kuavo_msgs.msg.armHandPose()
    else:
      self.header = std_msgs.msg.Header()
      self.left_pose = kuavo_msgs.msg.armHandPose()
      self.right_pose = kuavo_msgs.msg.armHandPose()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      buff.write(_get_struct_3d().pack(*self.left_pose.pos_xyz))
      buff.write(_get_struct_4d().pack(*self.left_pose.quat_xyzw))
      buff.write(_get_struct_3d().pack(*self.left_pose.elbow_pos_xyz))
      buff.write(_get_struct_7d().pack(*self.left_pose.joint_angles))
      buff.write(_get_struct_3d().pack(*self.right_pose.pos_xyz))
      buff.write(_get_struct_4d().pack(*self.right_pose.quat_xyzw))
      buff.write(_get_struct_3d().pack(*self.right_pose.elbow_pos_xyz))
      buff.write(_get_struct_7d().pack(*self.right_pose.joint_angles))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.left_pose is None:
        self.left_pose = kuavo_msgs.msg.armHandPose()
      if self.right_pose is None:
        self.right_pose = kuavo_msgs.msg.armHandPose()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 24
      self.left_pose.pos_xyz = _get_struct_3d().unpack(str[start:end])
      start = end
      end += 32
      self.left_pose.quat_xyzw = _get_struct_4d().unpack(str[start:end])
      start = end
      end += 24
      self.left_pose.elbow_pos_xyz = _get_struct_3d().unpack(str[start:end])
      start = end
      end += 56
      self.left_pose.joint_angles = _get_struct_7d().unpack(str[start:end])
      start = end
      end += 24
      self.right_pose.pos_xyz = _get_struct_3d().unpack(str[start:end])
      start = end
      end += 32
      self.right_pose.quat_xyzw = _get_struct_4d().unpack(str[start:end])
      start = end
      end += 24
      self.right_pose.elbow_pos_xyz = _get_struct_3d().unpack(str[start:end])
      start = end
      end += 56
      self.right_pose.joint_angles = _get_struct_7d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      buff.write(self.left_pose.pos_xyz.tostring())
      buff.write(self.left_pose.quat_xyzw.tostring())
      buff.write(self.left_pose.elbow_pos_xyz.tostring())
      buff.write(self.left_pose.joint_angles.tostring())
      buff.write(self.right_pose.pos_xyz.tostring())
      buff.write(self.right_pose.quat_xyzw.tostring())
      buff.write(self.right_pose.elbow_pos_xyz.tostring())
      buff.write(self.right_pose.joint_angles.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.left_pose is None:
        self.left_pose = kuavo_msgs.msg.armHandPose()
      if self.right_pose is None:
        self.right_pose = kuavo_msgs.msg.armHandPose()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 24
      self.left_pose.pos_xyz = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=3)
      start = end
      end += 32
      self.left_pose.quat_xyzw = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=4)
      start = end
      end += 24
      self.left_pose.elbow_pos_xyz = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=3)
      start = end
      end += 56
      self.left_pose.joint_angles = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=7)
      start = end
      end += 24
      self.right_pose.pos_xyz = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=3)
      start = end
      end += 32
      self.right_pose.quat_xyzw = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=4)
      start = end
      end += 24
      self.right_pose.elbow_pos_xyz = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=3)
      start = end
      end += 56
      self.right_pose.joint_angles = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=7)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_7d = None
def _get_struct_7d():
    global _struct_7d
    if _struct_7d is None:
        _struct_7d = struct.Struct("<7d")
    return _struct_7d
