# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ocs2_msgs/mpc_solver_data.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ocs2_msgs.msg

class mpc_solver_data(genpy.Message):
  _md5sum = "5d8e9cf6f256a05764e6ff2f6f246a7f"
  _type = "ocs2_msgs/mpc_solver_data"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """float64 initTime           # 对应 scalar_t initTime_
float64[] initState        # 对应 vector_t initState_
float64 finalTime          # 对应 scalar_t finalTime_

# ModeSchedule 和 TargetTrajectories 
mode_schedule modeSchedule
mpc_target_trajectories targetTrajectories

# 包含 PrimalSolution 
mpc_flattened_controller mpc_flattened_controller

# swingplanner存储的swingPlannerMultipliers
float64[] swingPlannerMultipliers

================================================================================
MSG: ocs2_msgs/mode_schedule
# MPC mode sequence

float64[] eventTimes           # event times: its size is equal to the size of phaseSequence minus one
int8[]    modeSequence         # mode sequence: e.g., for a quadrupedal robot, it is in the set {0, 1,..., 15}
================================================================================
MSG: ocs2_msgs/mpc_target_trajectories
# MPC target trajectories

float64[]    timeTrajectory        # MPC target time trajectory
mpc_state[]  stateTrajectory       # MPC target state trajectory
mpc_input[]  inputTrajectory       # MPC target input trajectory


================================================================================
MSG: ocs2_msgs/mpc_state
# MPC internal model state vector
float32[] value

================================================================================
MSG: ocs2_msgs/mpc_input
# MPC internal model input vector 

float32[] value
================================================================================
MSG: ocs2_msgs/mpc_flattened_controller
# Flattened controller: A serialized controller

# define controllerType Enum values
uint8 CONTROLLER_UNKNOWN=0 # safety mechanism: message initalization to zero
uint8 CONTROLLER_FEEDFORWARD=1
uint8 CONTROLLER_LINEAR=2

uint8                   controllerType         # what type of controller is this

mpc_observation         initObservation        # plan initial observation

mpc_target_trajectories planTargetTrajectories # target trajectory in cost function
mpc_state[]             stateTrajectory        # optimized state trajectory from planner
mpc_input[]             inputTrajectory        # optimized input trajectory from planner
float64[]               timeTrajectory         # time trajectory for stateTrajectory and inputTrajectory
uint16[]                postEventIndices       # array of indices indicating the index of post-event time in the trajectories
mode_schedule           modeSchedule           # optimal/predefined MPC mode sequence and event times

controller_data[]       data                   # the actual payload from flatten method: one vector of data per time step

mpc_performance_indices performanceIndices     # solver performance indices

================================================================================
MSG: ocs2_msgs/mpc_observation
# MPC observation
float64        time        # Current time
mpc_state      state       # Current state
mpc_input      input       # Current input
int8           mode        # Current mode

================================================================================
MSG: ocs2_msgs/controller_data
float32[] data

================================================================================
MSG: ocs2_msgs/mpc_performance_indices
# MPC performance indices
float32     initTime
float32     merit
float32     cost
float32     dynamicsViolationSSE
float32     equalityConstraintsSSE
float32     equalityLagrangian
float32     inequalityLagrangian
"""
  __slots__ = ['initTime','initState','finalTime','modeSchedule','targetTrajectories','mpc_flattened_controller','swingPlannerMultipliers']
  _slot_types = ['float64','float64[]','float64','ocs2_msgs/mode_schedule','ocs2_msgs/mpc_target_trajectories','ocs2_msgs/mpc_flattened_controller','float64[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       initTime,initState,finalTime,modeSchedule,targetTrajectories,mpc_flattened_controller,swingPlannerMultipliers

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(mpc_solver_data, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.initTime is None:
        self.initTime = 0.
      if self.initState is None:
        self.initState = []
      if self.finalTime is None:
        self.finalTime = 0.
      if self.modeSchedule is None:
        self.modeSchedule = ocs2_msgs.msg.mode_schedule()
      if self.targetTrajectories is None:
        self.targetTrajectories = ocs2_msgs.msg.mpc_target_trajectories()
      if self.mpc_flattened_controller is None:
        self.mpc_flattened_controller = ocs2_msgs.msg.mpc_flattened_controller()
      if self.swingPlannerMultipliers is None:
        self.swingPlannerMultipliers = []
    else:
      self.initTime = 0.
      self.initState = []
      self.finalTime = 0.
      self.modeSchedule = ocs2_msgs.msg.mode_schedule()
      self.targetTrajectories = ocs2_msgs.msg.mpc_target_trajectories()
      self.mpc_flattened_controller = ocs2_msgs.msg.mpc_flattened_controller()
      self.swingPlannerMultipliers = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.initTime
      buff.write(_get_struct_d().pack(_x))
      length = len(self.initState)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.initState))
      _x = self.finalTime
      buff.write(_get_struct_d().pack(_x))
      length = len(self.modeSchedule.eventTimes)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.modeSchedule.eventTimes))
      length = len(self.modeSchedule.modeSequence)
      buff.write(_struct_I.pack(length))
      pattern = '<%sb'%length
      buff.write(struct.Struct(pattern).pack(*self.modeSchedule.modeSequence))
      length = len(self.targetTrajectories.timeTrajectory)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.targetTrajectories.timeTrajectory))
      length = len(self.targetTrajectories.stateTrajectory)
      buff.write(_struct_I.pack(length))
      for val1 in self.targetTrajectories.stateTrajectory:
        length = len(val1.value)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.Struct(pattern).pack(*val1.value))
      length = len(self.targetTrajectories.inputTrajectory)
      buff.write(_struct_I.pack(length))
      for val1 in self.targetTrajectories.inputTrajectory:
        length = len(val1.value)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.Struct(pattern).pack(*val1.value))
      _x = self
      buff.write(_get_struct_Bd().pack(_x.mpc_flattened_controller.controllerType, _x.mpc_flattened_controller.initObservation.time))
      length = len(self.mpc_flattened_controller.initObservation.state.value)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.Struct(pattern).pack(*self.mpc_flattened_controller.initObservation.state.value))
      length = len(self.mpc_flattened_controller.initObservation.input.value)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.Struct(pattern).pack(*self.mpc_flattened_controller.initObservation.input.value))
      _x = self.mpc_flattened_controller.initObservation.mode
      buff.write(_get_struct_b().pack(_x))
      length = len(self.mpc_flattened_controller.planTargetTrajectories.timeTrajectory)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.mpc_flattened_controller.planTargetTrajectories.timeTrajectory))
      length = len(self.mpc_flattened_controller.planTargetTrajectories.stateTrajectory)
      buff.write(_struct_I.pack(length))
      for val1 in self.mpc_flattened_controller.planTargetTrajectories.stateTrajectory:
        length = len(val1.value)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.Struct(pattern).pack(*val1.value))
      length = len(self.mpc_flattened_controller.planTargetTrajectories.inputTrajectory)
      buff.write(_struct_I.pack(length))
      for val1 in self.mpc_flattened_controller.planTargetTrajectories.inputTrajectory:
        length = len(val1.value)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.Struct(pattern).pack(*val1.value))
      length = len(self.mpc_flattened_controller.stateTrajectory)
      buff.write(_struct_I.pack(length))
      for val1 in self.mpc_flattened_controller.stateTrajectory:
        length = len(val1.value)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.Struct(pattern).pack(*val1.value))
      length = len(self.mpc_flattened_controller.inputTrajectory)
      buff.write(_struct_I.pack(length))
      for val1 in self.mpc_flattened_controller.inputTrajectory:
        length = len(val1.value)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.Struct(pattern).pack(*val1.value))
      length = len(self.mpc_flattened_controller.timeTrajectory)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.mpc_flattened_controller.timeTrajectory))
      length = len(self.mpc_flattened_controller.postEventIndices)
      buff.write(_struct_I.pack(length))
      pattern = '<%sH'%length
      buff.write(struct.Struct(pattern).pack(*self.mpc_flattened_controller.postEventIndices))
      length = len(self.mpc_flattened_controller.modeSchedule.eventTimes)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.mpc_flattened_controller.modeSchedule.eventTimes))
      length = len(self.mpc_flattened_controller.modeSchedule.modeSequence)
      buff.write(_struct_I.pack(length))
      pattern = '<%sb'%length
      buff.write(struct.Struct(pattern).pack(*self.mpc_flattened_controller.modeSchedule.modeSequence))
      length = len(self.mpc_flattened_controller.data)
      buff.write(_struct_I.pack(length))
      for val1 in self.mpc_flattened_controller.data:
        length = len(val1.data)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.Struct(pattern).pack(*val1.data))
      _x = self
      buff.write(_get_struct_7f().pack(_x.mpc_flattened_controller.performanceIndices.initTime, _x.mpc_flattened_controller.performanceIndices.merit, _x.mpc_flattened_controller.performanceIndices.cost, _x.mpc_flattened_controller.performanceIndices.dynamicsViolationSSE, _x.mpc_flattened_controller.performanceIndices.equalityConstraintsSSE, _x.mpc_flattened_controller.performanceIndices.equalityLagrangian, _x.mpc_flattened_controller.performanceIndices.inequalityLagrangian))
      length = len(self.swingPlannerMultipliers)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.swingPlannerMultipliers))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.modeSchedule is None:
        self.modeSchedule = ocs2_msgs.msg.mode_schedule()
      if self.targetTrajectories is None:
        self.targetTrajectories = ocs2_msgs.msg.mpc_target_trajectories()
      if self.mpc_flattened_controller is None:
        self.mpc_flattened_controller = ocs2_msgs.msg.mpc_flattened_controller()
      end = 0
      start = end
      end += 8
      (self.initTime,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.initState = s.unpack(str[start:end])
      start = end
      end += 8
      (self.finalTime,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.modeSchedule.eventTimes = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sb'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.modeSchedule.modeSequence = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.targetTrajectories.timeTrajectory = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.targetTrajectories.stateTrajectory = []
      for i in range(0, length):
        val1 = ocs2_msgs.msg.mpc_state()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.value = s.unpack(str[start:end])
        self.targetTrajectories.stateTrajectory.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.targetTrajectories.inputTrajectory = []
      for i in range(0, length):
        val1 = ocs2_msgs.msg.mpc_input()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.value = s.unpack(str[start:end])
        self.targetTrajectories.inputTrajectory.append(val1)
      _x = self
      start = end
      end += 9
      (_x.mpc_flattened_controller.controllerType, _x.mpc_flattened_controller.initObservation.time,) = _get_struct_Bd().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.mpc_flattened_controller.initObservation.state.value = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.mpc_flattened_controller.initObservation.input.value = s.unpack(str[start:end])
      start = end
      end += 1
      (self.mpc_flattened_controller.initObservation.mode,) = _get_struct_b().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.mpc_flattened_controller.planTargetTrajectories.timeTrajectory = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mpc_flattened_controller.planTargetTrajectories.stateTrajectory = []
      for i in range(0, length):
        val1 = ocs2_msgs.msg.mpc_state()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.value = s.unpack(str[start:end])
        self.mpc_flattened_controller.planTargetTrajectories.stateTrajectory.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mpc_flattened_controller.planTargetTrajectories.inputTrajectory = []
      for i in range(0, length):
        val1 = ocs2_msgs.msg.mpc_input()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.value = s.unpack(str[start:end])
        self.mpc_flattened_controller.planTargetTrajectories.inputTrajectory.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mpc_flattened_controller.stateTrajectory = []
      for i in range(0, length):
        val1 = ocs2_msgs.msg.mpc_state()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.value = s.unpack(str[start:end])
        self.mpc_flattened_controller.stateTrajectory.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mpc_flattened_controller.inputTrajectory = []
      for i in range(0, length):
        val1 = ocs2_msgs.msg.mpc_input()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.value = s.unpack(str[start:end])
        self.mpc_flattened_controller.inputTrajectory.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.mpc_flattened_controller.timeTrajectory = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sH'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.mpc_flattened_controller.postEventIndices = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.mpc_flattened_controller.modeSchedule.eventTimes = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sb'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.mpc_flattened_controller.modeSchedule.modeSequence = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mpc_flattened_controller.data = []
      for i in range(0, length):
        val1 = ocs2_msgs.msg.controller_data()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.data = s.unpack(str[start:end])
        self.mpc_flattened_controller.data.append(val1)
      _x = self
      start = end
      end += 28
      (_x.mpc_flattened_controller.performanceIndices.initTime, _x.mpc_flattened_controller.performanceIndices.merit, _x.mpc_flattened_controller.performanceIndices.cost, _x.mpc_flattened_controller.performanceIndices.dynamicsViolationSSE, _x.mpc_flattened_controller.performanceIndices.equalityConstraintsSSE, _x.mpc_flattened_controller.performanceIndices.equalityLagrangian, _x.mpc_flattened_controller.performanceIndices.inequalityLagrangian,) = _get_struct_7f().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.swingPlannerMultipliers = s.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.initTime
      buff.write(_get_struct_d().pack(_x))
      length = len(self.initState)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.initState.tostring())
      _x = self.finalTime
      buff.write(_get_struct_d().pack(_x))
      length = len(self.modeSchedule.eventTimes)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.modeSchedule.eventTimes.tostring())
      length = len(self.modeSchedule.modeSequence)
      buff.write(_struct_I.pack(length))
      pattern = '<%sb'%length
      buff.write(self.modeSchedule.modeSequence.tostring())
      length = len(self.targetTrajectories.timeTrajectory)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.targetTrajectories.timeTrajectory.tostring())
      length = len(self.targetTrajectories.stateTrajectory)
      buff.write(_struct_I.pack(length))
      for val1 in self.targetTrajectories.stateTrajectory:
        length = len(val1.value)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.value.tostring())
      length = len(self.targetTrajectories.inputTrajectory)
      buff.write(_struct_I.pack(length))
      for val1 in self.targetTrajectories.inputTrajectory:
        length = len(val1.value)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.value.tostring())
      _x = self
      buff.write(_get_struct_Bd().pack(_x.mpc_flattened_controller.controllerType, _x.mpc_flattened_controller.initObservation.time))
      length = len(self.mpc_flattened_controller.initObservation.state.value)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.mpc_flattened_controller.initObservation.state.value.tostring())
      length = len(self.mpc_flattened_controller.initObservation.input.value)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.mpc_flattened_controller.initObservation.input.value.tostring())
      _x = self.mpc_flattened_controller.initObservation.mode
      buff.write(_get_struct_b().pack(_x))
      length = len(self.mpc_flattened_controller.planTargetTrajectories.timeTrajectory)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.mpc_flattened_controller.planTargetTrajectories.timeTrajectory.tostring())
      length = len(self.mpc_flattened_controller.planTargetTrajectories.stateTrajectory)
      buff.write(_struct_I.pack(length))
      for val1 in self.mpc_flattened_controller.planTargetTrajectories.stateTrajectory:
        length = len(val1.value)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.value.tostring())
      length = len(self.mpc_flattened_controller.planTargetTrajectories.inputTrajectory)
      buff.write(_struct_I.pack(length))
      for val1 in self.mpc_flattened_controller.planTargetTrajectories.inputTrajectory:
        length = len(val1.value)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.value.tostring())
      length = len(self.mpc_flattened_controller.stateTrajectory)
      buff.write(_struct_I.pack(length))
      for val1 in self.mpc_flattened_controller.stateTrajectory:
        length = len(val1.value)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.value.tostring())
      length = len(self.mpc_flattened_controller.inputTrajectory)
      buff.write(_struct_I.pack(length))
      for val1 in self.mpc_flattened_controller.inputTrajectory:
        length = len(val1.value)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.value.tostring())
      length = len(self.mpc_flattened_controller.timeTrajectory)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.mpc_flattened_controller.timeTrajectory.tostring())
      length = len(self.mpc_flattened_controller.postEventIndices)
      buff.write(_struct_I.pack(length))
      pattern = '<%sH'%length
      buff.write(self.mpc_flattened_controller.postEventIndices.tostring())
      length = len(self.mpc_flattened_controller.modeSchedule.eventTimes)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.mpc_flattened_controller.modeSchedule.eventTimes.tostring())
      length = len(self.mpc_flattened_controller.modeSchedule.modeSequence)
      buff.write(_struct_I.pack(length))
      pattern = '<%sb'%length
      buff.write(self.mpc_flattened_controller.modeSchedule.modeSequence.tostring())
      length = len(self.mpc_flattened_controller.data)
      buff.write(_struct_I.pack(length))
      for val1 in self.mpc_flattened_controller.data:
        length = len(val1.data)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.data.tostring())
      _x = self
      buff.write(_get_struct_7f().pack(_x.mpc_flattened_controller.performanceIndices.initTime, _x.mpc_flattened_controller.performanceIndices.merit, _x.mpc_flattened_controller.performanceIndices.cost, _x.mpc_flattened_controller.performanceIndices.dynamicsViolationSSE, _x.mpc_flattened_controller.performanceIndices.equalityConstraintsSSE, _x.mpc_flattened_controller.performanceIndices.equalityLagrangian, _x.mpc_flattened_controller.performanceIndices.inequalityLagrangian))
      length = len(self.swingPlannerMultipliers)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.swingPlannerMultipliers.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.modeSchedule is None:
        self.modeSchedule = ocs2_msgs.msg.mode_schedule()
      if self.targetTrajectories is None:
        self.targetTrajectories = ocs2_msgs.msg.mpc_target_trajectories()
      if self.mpc_flattened_controller is None:
        self.mpc_flattened_controller = ocs2_msgs.msg.mpc_flattened_controller()
      end = 0
      start = end
      end += 8
      (self.initTime,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.initState = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 8
      (self.finalTime,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.modeSchedule.eventTimes = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sb'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.modeSchedule.modeSequence = numpy.frombuffer(str[start:end], dtype=numpy.int8, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.targetTrajectories.timeTrajectory = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.targetTrajectories.stateTrajectory = []
      for i in range(0, length):
        val1 = ocs2_msgs.msg.mpc_state()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.value = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.targetTrajectories.stateTrajectory.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.targetTrajectories.inputTrajectory = []
      for i in range(0, length):
        val1 = ocs2_msgs.msg.mpc_input()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.value = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.targetTrajectories.inputTrajectory.append(val1)
      _x = self
      start = end
      end += 9
      (_x.mpc_flattened_controller.controllerType, _x.mpc_flattened_controller.initObservation.time,) = _get_struct_Bd().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.mpc_flattened_controller.initObservation.state.value = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.mpc_flattened_controller.initObservation.input.value = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 1
      (self.mpc_flattened_controller.initObservation.mode,) = _get_struct_b().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.mpc_flattened_controller.planTargetTrajectories.timeTrajectory = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mpc_flattened_controller.planTargetTrajectories.stateTrajectory = []
      for i in range(0, length):
        val1 = ocs2_msgs.msg.mpc_state()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.value = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.mpc_flattened_controller.planTargetTrajectories.stateTrajectory.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mpc_flattened_controller.planTargetTrajectories.inputTrajectory = []
      for i in range(0, length):
        val1 = ocs2_msgs.msg.mpc_input()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.value = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.mpc_flattened_controller.planTargetTrajectories.inputTrajectory.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mpc_flattened_controller.stateTrajectory = []
      for i in range(0, length):
        val1 = ocs2_msgs.msg.mpc_state()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.value = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.mpc_flattened_controller.stateTrajectory.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mpc_flattened_controller.inputTrajectory = []
      for i in range(0, length):
        val1 = ocs2_msgs.msg.mpc_input()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.value = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.mpc_flattened_controller.inputTrajectory.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.mpc_flattened_controller.timeTrajectory = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sH'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.mpc_flattened_controller.postEventIndices = numpy.frombuffer(str[start:end], dtype=numpy.uint16, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.mpc_flattened_controller.modeSchedule.eventTimes = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sb'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.mpc_flattened_controller.modeSchedule.modeSequence = numpy.frombuffer(str[start:end], dtype=numpy.int8, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mpc_flattened_controller.data = []
      for i in range(0, length):
        val1 = ocs2_msgs.msg.controller_data()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.data = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.mpc_flattened_controller.data.append(val1)
      _x = self
      start = end
      end += 28
      (_x.mpc_flattened_controller.performanceIndices.initTime, _x.mpc_flattened_controller.performanceIndices.merit, _x.mpc_flattened_controller.performanceIndices.cost, _x.mpc_flattened_controller.performanceIndices.dynamicsViolationSSE, _x.mpc_flattened_controller.performanceIndices.equalityConstraintsSSE, _x.mpc_flattened_controller.performanceIndices.equalityLagrangian, _x.mpc_flattened_controller.performanceIndices.inequalityLagrangian,) = _get_struct_7f().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.swingPlannerMultipliers = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_7f = None
def _get_struct_7f():
    global _struct_7f
    if _struct_7f is None:
        _struct_7f = struct.Struct("<7f")
    return _struct_7f
_struct_Bd = None
def _get_struct_Bd():
    global _struct_Bd
    if _struct_Bd is None:
        _struct_Bd = struct.Struct("<Bd")
    return _struct_Bd
_struct_b = None
def _get_struct_b():
    global _struct_b
    if _struct_b is None:
        _struct_b = struct.Struct("<b")
    return _struct_b
_struct_d = None
def _get_struct_d():
    global _struct_d
    if _struct_d is None:
        _struct_d = struct.Struct("<d")
    return _struct_d
